"""
1、鉴权
2、根据项目情况来进行封装
"""
import requests
import json

from Common.my_logger import logger
from Common.handle_config import conf


def send_request(method, url, data=None, token=None):
    # 请求头信息
    headers = __handle_headers(token)
    # url处理，拼接获取完整的url
    url = __pre_url(url)
    # data处理，把字符转化为字典
    data = __pre_data(data)
    logger.info("请求头为：{}".format(headers))
    logger.info("请求方法为：{}".format(method))
    logger.info("请求url为：{}".format(url))
    logger.info("请求数据为：{}".format(data))
    if method.upper() == "GET":
        resp = requests.get(url, data, headers=headers)
    elif method.upper() == "POST":
        resp = requests.post(url, json=data, headers=headers)
    elif method.upper() == "PUT":
        resp = requests.put(url, json=data, headers=headers)
    else:
        print("请求方式存在问题，请检查！")
    logger.info("响应状态码为：{}".format(resp.status_code))
    logger.info("响应数据为：{}".format(resp.json()))
    return resp


def __handle_headers(token=None):
    headers = {'App': 'galaxy-admin', 'Content-Type': 'application/json'}
    if token:
        headers['token'] = '{}'.format(token)
    return headers


def __pre_url(url):
    if url.startswith("/"):
        url = conf.get("server", "base_url") + url
    else:
        url = conf.get("server", "base_url") + "/" + url
    return url


def __pre_data(data):
    # 如果data不为空并且为字符类型时，转化为字典，或者不处理
    if data is not None and isinstance(data, str):
        return json.loads(data)
    return data


if __name__ == '__main__':
    # login_url = "http://api.lemonban.com/futureloan/member/login"
    # login_data = {"mobile_phone": "18112345686", "pwd": "12345678"}
    # resp = send_request("post", login_url, login_data)
    # print(resp.json())
    # resp_dict = resp.json()
    # token = resp_dict['data']['token_info']['token']
    # member_id = resp_dict['data']['id']

    # recharge_url = "http://api.lemonban.com/futureloan/member/recharge"
    # recharge_data = {"member_id": member_id, "amount": 200}
    # resp = send_request("post", recharge_url, recharge_data, token)
    # print(resp.json())

    login_url = "http://api.lemonban.com/futureloan/member/register"
    login_data = {"mobile_phone": "18112345679", "pwd": "12345678"}
    resp = send_request("post", login_url, login_data)
    print(resp.json())
    print(resp.json()['code'])
    print(type(login_data))
